From 3fe5e2c2204226ca2a60f7f93e57c7bb99ffa623 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 16 2020 07:49:55 +0000
Subject: [PATCH 137/2232] Merge pull request #70 from dtolnay/result


Parse Result<T> return type
---

diff --git a/syntax/check.rs b/syntax/check.rs
index ef3faff..80937bb 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -69,6 +69,12 @@ pub(crate) fn typecheck(apis: &[Api], types: &Types) -> Result<()> {
                         errors.push(return_by_value(ty, types));
                     }
                 }
+                if efn.throws {
+                    errors.push(Error::new_spanned(
+                        efn,
+                        "fallible functions are not implemented yet",
+                    ));
+                }
             }
             _ => {}
         }
diff --git a/syntax/mod.rs b/syntax/mod.rs
index 8c7e5ca..5b51648 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -50,6 +50,7 @@ pub struct ExternFn {
     pub receiver: Option<Receiver>,
     pub args: Vec<Var>,
     pub ret: Option<Type>,
+    pub throws: bool,
     pub semi_token: Token![;],
 }
 
diff --git a/syntax/parse.rs b/syntax/parse.rs
index 67bb52b..7bae707 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -178,13 +178,34 @@ fn parse_extern_fn(foreign_fn: &ForeignItemFn) -> Result<ExternFn> {
             }
         }
     }
+
+    let mut throws = false;
     let ret = match &foreign_fn.sig.output {
         ReturnType::Default => None,
-        ReturnType::Type(_, ty) => match parse_type(ty)? {
-            Type::Void(_) => None,
-            ty => Some(ty),
-        },
+        ReturnType::Type(_, ret) => {
+            let mut ret = ret.as_ref();
+            if let RustType::Path(ty) = ret {
+                let path = &ty.path;
+                if ty.qself.is_none() && path.leading_colon.is_none() && path.segments.len() == 1 {
+                    let segment = &path.segments[0];
+                    let ident = segment.ident.clone();
+                    if let PathArguments::AngleBracketed(generic) = &segment.arguments {
+                        if ident == "Result" && generic.args.len() == 1 {
+                            if let GenericArgument::Type(arg) = &generic.args[0] {
+                                ret = arg;
+                                throws = true;
+                            }
+                        }
+                    }
+                }
+            }
+            match parse_type(ret)? {
+                Type::Void(_) => None,
+                ty => Some(ty),
+            }
+        }
     };
+
     let doc = attrs::parse_doc(&foreign_fn.attrs)?;
     let fn_token = foreign_fn.sig.fn_token;
     let ident = foreign_fn.sig.ident.clone();
@@ -196,12 +217,13 @@ fn parse_extern_fn(foreign_fn: &ForeignItemFn) -> Result<ExternFn> {
         receiver,
         args,
         ret,
+        throws,
         semi_token,
     })
 }
 
 fn parse_type(ty: &RustType) -> Result<Type> {
-    match &ty {
+    match ty {
         RustType::Reference(ty) => {
             let inner = parse_type(&ty.elem)?;
             let which = match &inner {

